<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<META NAME="generator" CONTENT="http://txt2tags.org">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf8">
<LINK REL="stylesheet" TYPE="text/css" HREF="../../style/style.css">
</HEAD><BODY BGCOLOR="white" TEXT="black">
<CENTER>
</CENTER>


<H1>Octal é a Vovozinha</H1>

<P>
<B><I>Colaboração: Paulo Roberto Bagatini</I></B>
</P>
<P>
<B><I>Data de Publicação: 26 de maio de 2014</I></B>
</P>
<P>
Ninguém está livre de ser pego desprevinido pela notação numérica do BASh:
</P>

<PRE>
  $ echo $((010+070)) # 1
  64
  $ echo $(( 10+070)) # 2
  66
  $ echo $((010+ 70)) # 3
  78
  $ echo $((010+ 90)) # 4
  98
  $ echo $(( 10+090)) # 5
  bash: 10+090: valor muito grande para esta base de numeração (token com erro é "090")
</PRE>

<P>
QUÊ BASE de numeração, tchê?
</P>
<P>
<B>Octal</B>, é claro. O BASh considera números que iniciam com zero como estando na base 8.
Se estão na base 8, não podem ter dígitos maiores que 7 ;-)
</P>
<P>
Na dica <A HREF="http://www.dicas-l.com.br/arquivo/bashes_numericas_no_bash.php">Bashes Numéricas no BASh</A>,
foi mostrado que o BASh trabalha nativa e simultaneamente com bases numéricas diferentes:
</P>

<UL>
<LI>no caso 1 acima, somando 2 números octais
<LI>no caso 2, 10 em decimal e 70 em octal
<LI>no caso 3, 10 em octal   e 70 em decimal
<LI>no caso 4, 10 em octal   e 90 em decimal
<LI>no caso 5, 10 em decimal e 90 em octal, o que provoca um erro, uma vez que não temos
  o dígito 9 nessa base.
</UL>

<P>
Quando a operação ocorre interativamente e com números, no "estilo calculadora",
basta não usar o zero cabide, e tudo estará resolvido:
</P>

<PRE>
  $ echo $((10+70))
  80
  
  $ echo $((10+90))
  100
</PRE>

<P>
Mas às vezes os números estão escondidos em variáveis. Às vezes a quantidade de dígitos
foi padronizada com o comando <B>printf</B>, ou os valores foram gerados a partir da expansão
de chaves (brace expansion) <B>{000..010}</B> ou com o comando <B>seq</B>. Outras vezes, simplesmente
nos damos conta que uma variável que não era pra ter nada de anormal apareceu com um
zero na frente do conteúdo, e agora temos que ficar implantando <I>patches</I> no nosso
algoritmo para driblar essa idiossincrasia do nosso amigo BASh :-p
</P>
<P>
Em vez de apelar para o <B>sed</B> ou <B>tr</B> para tirar os zeros cabide salvando o resultado em
uma variável auxiliar, podemos usar a notação explícita de bases numéricas do BASh e
deixar bem claro para o shell que SIM, estamos trabalhando na base decimal! Pombas...
</P>

<PRE>
  $ a=11
  $ b=209
  $ echo $((a+b))
  # OK
  
  $ a=$(printf %04d 11)  # 0011
  $ b=$(printf %06d 209) # 000209
  $ echo $((a+b))
  bash: 000209: valor muito grande para esta base de numeração (token com erro é "000209")
  # Ops...
  
  $ echo $((10#$a+10#$b))
  220
  # OK novamente
</PRE>

<P>
Observem a necessidade de deixar explícito também o que é variável e o que é dígito,
quando usamos a notação explícita de base numérica:
</P>

<PRE>
  $ echo $((10#a+10#b))
  bash: 10#a: valor muito grande para esta base de numeração (token com erro é "10#a")
</PRE>

<!-- html code generated by txt2tags 2.6 (http://txt2tags.org) -->
<!-- cmdline: txt2tags -t html -\-encoding=utf8 -\-style=../style/style.css dica.t2t -->
</BODY></HTML>
